val q: List[Int] = List(1, 2, 3)
val p: List[Int] = List(4, 5, 6)

// 1.
for (x <- q) yield x * 2
q.map(x => x * 2)

// 2.
for (x <- q if x != 2) yield x * 2
q.filter(x => x !=2).map(x => x * 2)

// 3.
for (x <- q;
     y <- p) yield (x, y)
q.flatMap(x => p.map(y => (x, y)))

// 4.
for (x <- q if (x < 2);
     y <- p) yield (x, y)
q.filter(x => x < 2).flatMap(x => p.map(y => (x, y)))


for (x <- 1 to 2;
     y <- 'a' to 'b') yield (x, y)
(1 to 2).flatMap(x => ('a' to 'b').map(y => (x, y)))