import scala.annotation.tailrec

def foo(x: Int): Int = {
  println("Foo !")
  x + 1
}

def bar(x: => Int): Unit = {
  println("x1=" + x)
  println("x2=" + x)
}

bar(foo(3))
// Foo !
// x1=4
// Foo !
// x2=4


def toUpper(s: String): String = {
  @tailrec
  def helper(s: String, res: String): String = {
    if (s.isEmpty) res
    else helper(s.tail, res + s.head.toUpper)
  }
  helper(s, "")
}

toUpper("hello")